/*
このファイルの中身は、NTT オープンソースライセンス　バージョン 1.0（「本
契約」という）の適用を受けます。
本契約を遵守しない限り、このファイルを使用してはなりません。
本契約のコピーは、次のＵＲＬから入手できます。
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

本契約に基づき頒布されるソフトウェアは、現状のまま、明示又は黙示のあらゆ
る種類の保証なしで、頒布されます。本契約に基づく権利及び制限を律する特定
の文言については、本契約を参照してください。

「オリジナルコード」は、 NTT Cyber Space Laboratories Code です。 
「オリジナルコード」の「初期開発者」は、日本電信電話株式会社です。  
日本電信電話株式会社により創作された部分は、Copyright (C) 2004 
日本電信電話株式会社 です。
全ての権利が留保されます。 
「コントリビュータ」：_____________________________________ 


The contents of this file are subject to the NTT Opensource License
Version 1.0 (the License); you may not use this file except in
compliance with the License. You may obtain a copy of the License at
【配布サイトのURL】 http://www.oss.ecl.ntt.co.jp/lms/

Software distributed under the License is distributed on an AS IS
basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
License for the specific language governing rights and limitations
under the License.

The Original Code is NTT Cyber Space Laboratories Code .

The Initial Developer of the Original Code is NIPPON TELEGRAPH AND 
TELEPHONE CORPORATION.
Portions created by the NIPPON TELEGRAPH AND TELEPHONE CORPORATION 
are Copyright (C) 2004 NIPPON TELEGRAPH AND TELEPHONE CORPORATION. 
All Rights Reserved.

Contributor(s) ______________________________________.
*/

//
//	MakeButtonBusinessAction
//	変更履歴
//		2004.02.01	新規作成
//

package jp.co.ntt.lms.lo.scorm.engine;

import java.io.File;
import java.io.PrintWriter;
import java.io.StringWriter;

import javax.servlet.ServletContext;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import jp.co.ntt.lms.lo.scorm.kernel.AuxiliaryResource;
import jp.co.ntt.lms.lo.scorm.kernel.exception.SequencingException;
import jp.co.ntt.lms.lo.scorm.util.SG;
import jp.co.ntt.lms.lo.scorm.util.XMLUtil;
import jp.co.ntt.lms.xms.framework.XmsBusinessAction;
import jp.co.ntt.lms.xms.framework.XmsException;
import jp.co.ntt.lms.xms.framework.XmsRequest;
import jp.co.ntt.lms.xms.framework.XmsResponse;
import jp.co.ntt.lms.xms.framework.XmsSystemException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 *	MakeButtonBusinessAction クラス<br>
 *	ボタンフレーム画面の作成要求を受け付けるクラス<br>
 */
public class MakeButtonBusinessAction extends XmsBusinessAction {
	/**
	 * デフォルトコンストラクタ
	 */
	public MakeButtonBusinessAction() {}

	/**
	 * 初期化処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 */
	protected void initProcessRequest(XmsRequest xmsRequest) throws XmsException {}

	/**
	 * ボタンフレーム作成要求受付処理
	 *
	 * @param	xmsRequest	リクエストオブジェクト
	 * @param	xmsResponse	レスポンスオブジェクト
	 */
	protected void processRequest(XmsRequest xmsRequest, XmsResponse xmsResponse) throws XmsException {
		try {
			HttpServletRequest request = xmsRequest.getRequest();
			HttpSession session = request.getSession();
			ServletContext application = session.getServletContext();

			// 起動パラメータをsessionから取得する
			ExecuteParameters executeParameters =
				(ExecuteParameters)session.getAttribute("SCORM.EXECUTE_PARAMETERS");

			// sessionから取得できなかった場合 → Session Timeout 発生時
			if (executeParameters == null) {
				xmsResponse.setBusinessStatus("SessionTimeout");
				return;
			}

			// エンジンをapplicationから取得する
			String engineKeyName =
				"SCORM." + executeParameters.getUserID() + "." + executeParameters.getLOID() + ".ENGINE";

			Engine engine = (Engine)application.getAttribute(engineKeyName);

			// <Button>ルートタグを作成する
			Document doc = XMLUtil.createDocument("Button", false);
			Element rootNode = doc.getDocumentElement();

			// <UserInformation>タグを作成する
			XMLUtil.append(
				doc,
				rootNode,
				"UserInformation",
				new Element[] {
					XMLUtil.createElement(doc, "ID", executeParameters.getUserID()),
					XMLUtil.createElement(doc, "Name", executeParameters.getUserName())});

			// <ContentsInformation>タグを作成する
			XMLUtil.append(
				doc,
				rootNode,
				"ContentsInformation",
				new Element[] {
					XMLUtil.createElement(doc, "Title", engine.getTitle()),
					XMLUtil.createElement(doc, "ExternalID", executeParameters.getForeignLOID()),
					XMLUtil.createElement(doc, "ManifestID", executeParameters.getManifestID()),
					XMLUtil.createElement(doc, "StudySessionCount", executeParameters.getStudySessionCount()),
					XMLUtil.createElement(doc, "LoginSessionCount", executeParameters.getLaunchCount()),
					XMLUtil.createElement(
						doc,
						"BaseURL",
						SG.get("ContentsBaseURL") + executeParameters.getManifestID() + File.separator),
					XMLUtil.createElement(doc, "ScriptURL", SG.get("LMSUIScriptURL")),
					});

			// シーケンシング例外が発生している時のみ<ExceptionInformation>タグを作成する
			SequencingException sequencingException = engine.getLastSequencingException();
			if (sequencingException != null) {
				String[] exceptionName = sequencingException.getClass().toString().split("\\.");

				XMLUtil.append(
					doc,
					rootNode,
					"ExceptionInformation",
					exceptionName[exceptionName.length - 1]);

				if (SG.get("SetExceptionInformationDetail") != null) {
					StringWriter sw = new StringWriter();

					sequencingException.printStackTrace(new PrintWriter(sw));

					XMLUtil.append(doc, rootNode, "ExceptionInformationDetail", sw.toString());
				}
			}

			// <AuxiliaryResource>タグを作成する
			AuxiliaryResource[] auxiliaryResources = engine.getAuxiliaryResources();
			Element[] auxiallyResourceNodes = null;
			if (auxiliaryResources != null) {
				auxiallyResourceNodes = new Element[auxiliaryResources.length];

				for (int i = 0; i < auxiliaryResources.length; i++) {
					auxiallyResourceNodes[i] =
						XMLUtil.createElement(
							doc,
							"AuxiliaryResource",
							new Element[] {
								XMLUtil.createElement(
									doc,
									"ResourceID",
									auxiliaryResources[i].getResourceID()),
								XMLUtil.createElement(doc, "Purpose", auxiliaryResources[i].getPurpose()),
								});
				}
			}

			// <ActivityInformation>タグを作成する
			String[] hideLMSUI = engine.getHideLMSUI();

			boolean canPrevious = engine.canPrevious();
			boolean canContinue = engine.canContinue();
			boolean canExit = engine.canExit();
			boolean canExitAll = engine.canExitAll();
			boolean canSuspendAll = engine.canSuspendAll();

			if (hideLMSUI != null) {
				for (int i = 0; i < hideLMSUI.length; i++) {
					if ("previous".equals(hideLMSUI[i])) {
						canPrevious = false;
					}
					else if ("continue".equals(hideLMSUI[i])) {
						canContinue = false;
					}
					else if ("exit".equals(hideLMSUI[i])) {
						canExit = canExitAll = false;
					}
				}
			}

			XMLUtil.append(
				doc,
				rootNode,
				"ActivityInformation",
				new Element[] {
					XMLUtil.createElement(doc, "ActivityID", engine.getActivityID()),
					XMLUtil.createElement(
						doc,
						"SequencingInformation",
						new Element[] {
							XMLUtil.createElement(doc, "CanPrevious", Boolean.toString(canPrevious)),
							XMLUtil.createElement(doc, "CanContinue", Boolean.toString(canContinue)),
							XMLUtil.createElement(doc, "CanExit", Boolean.toString(canExit)),
							XMLUtil.createElement(doc, "CanExitAll", Boolean.toString(canExitAll)),
							XMLUtil.createElement(doc, "CanSuspendAll", Boolean.toString(canSuspendAll)),
							}),
					XMLUtil.createElement(doc, "AuxiliaryResources", auxiallyResourceNodes),
					});

			XSLTBusinessBean XSLTBusinessBean = new XSLTBusinessBean(executeParameters);

			XSLTBusinessBean.setDOMDocument(doc);

			xmsResponse.setBusinessBean(XSLTBusinessBean);
		}
		catch (Exception ex) {
			throw new XmsSystemException(ex);
		}
	}
}
